/* Problem URL: https://codeforces.com/problemset/problem/1986/F */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n, m;
    cin >> n >> m;

    V<V<pair<int, int>>> graph(n);
    V<bool> rem(m);
    while (m--) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        graph[a].emplace_back(b, m);
        graph[b].emplace_back(a, m);
    }

    V<bool> vis(n);
    vi t(n);
    vi mi(n);
    int tim = 0;
    int tt = 1;
    function<int(int, int)> dfs = [&](int i, int p) {
        vis[i] = true;
        t[i] = tim++;
        mi[i] = t[i];

        for (auto [j, ind] : graph[i]) {
            if (j == p) {
                continue;
            }

            if (vis[j]) {
                rmin(mi[i], t[j]);
                continue;
            }

            rmin(mi[i], dfs(j, i));
            if (mi[j] > t[i]) {
                rem[ind] = true;
                tt++;
            }
        }

        return mi[i];
    };

    dfs(0, 0);

    vl c(tt);
    vi g(n);
    vvi act(tt);
    int cur = 0;
    fill(all(vis), false);

    function<void(int)> func = [&](int i) {
        vis[i] = true;
        g[i] = cur;
        c[cur]++;
        for (auto [j, ind] : graph[i]) {
            if (vis[j] || rem[ind]) {
                continue;
            }

            func(j);
        }
    };

    rep(i, n) {
        if (vis[i]) {
            continue;
        }
        func(i);
        cur++;
    }

    rep(i, n) {
        for (auto [j, ind] : graph[i]) {
            if (rem[ind]) {
                act[g[i]].push_back(g[j]);
                act[g[j]].push_back(g[i]);
            }
        }
    }

    repv(i, act) {
        sortv(i);
        i.erase(unique(all(i)), i.end());
    }

    ll ans = (ll)n * (n - 1) / 2;
    function<ll(int, int)> calc = [&](int i, int p) {
        ll count = c[i];
        repv(j, act[i]) {
            if (j == p) {
                continue;
            }

            ll tm = calc(j, i);
            rmin(ans, tm * (tm - 1) / 2 + (n - tm) * (n - tm - 1) / 2);
            count += tm;
        }
        return count;
    };

    calc(0, 0);
    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
